# Inspired by livna 
# stuff to be implemented externally:
Source10: kmodtool
%define   kmodtool bash %{SOURCE10}
# end stuff to be ...

# hardcode for now:
%{!?kversion: %define kversion 2.6.19-1.2911.6.5.fc6}

%define kmod_name wlan-ng
%define kverrel %(%{kmodtool} verrel %{?kversion} 2>/dev/null)

%define upvar ""
%ifarch i686
%define paevar PAE
%endif
%ifarch ppc
%define smpvar smp
%endif
%ifarch i686 x86_64
%define xenvar xen
%define kdumpvar kdump
%endif
%ifarch i686 x86_64 ppc
%define kdumpvar kdump
%endif
%{!?kvariants: %define kvariants %{?upvar} %{?smpvar} %{?paevar} %{?xenvar} %{?kdumpvar}}

Name:           %{kmod_name}-kmod
Version:        0.2.5
Release:        6.%(echo %{kverrel} | tr - _)
Summary:        Kernel module for wlan-ng 802.11 wireless devices 
Group:          System Environment/Kernel
License:        GPL
URL:            http://www.linux-wlan.com/linux-wlan/
Source0:	ftp://ftp.linux-wlan.org/pub/linux-wlan-ng/linux-wlan-ng-%{version}.tar.bz2
Patch0:		linux-wlan-ng-0.2.5-kernel-2.6.19.patch
Patch1:		linux-wlan-ng-0.2.5-sandbox.patch
patch3: 	http://patches.aircrack-ng.org/linux-wlan-0.2.3.packet.injection.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
ExclusiveArch:	i586 i686 x86_64


%description
This package contains the  wlan-ng Driver for WiFi, a linux
device driver for 802.11a/b universal NIC cards - either Cardbus,
PCI or MiniPCI - that use the Prism 2/2.5/3 chipsets.


# magic hidden here:
%{expand:%(%{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null)}


%prep
# to understand the magic better or to debug it, uncomment this:
#{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null
#sleep 5
%setup -q -c -n linux-wlan-ng-%{version}

## kwizart - required since 2.6.18-1.2200.fc5
#grep -rlF '<linux/config.h>' linux-%{kmod_name}-%{version} \
#| xargs sed -i -e 's|<linux/config.h>|<linux/autoconf.h>|'

pushd linux-wlan-ng-%{version}
%patch0 -p0
%patch1 -p1
%patch3 -p1


cat << EOF > default.config
PRISM2_PCMCIA=n
PRISM2_PLX=n
PRISM2_PCI=n
PRISM2_USB=y
TARGET_ROOT_ON_HOST=${RPM_BUILD_ROOT}
TARGET_INST_EXEDIR=${RPM_BUILD_ROOT}%{_sbindir}
INSTALL_DEPMOD=n
PREFIX=%{_prefix}
INST_EXEDIR=%{_sbindir}
EOF

popd

for kvariant in %{kvariants} ; do
    cp -a linux-wlan-ng-%{version} _kmod_build_$kvariant
done


%build
for kvariant in %{kvariants}
do
    ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
    pushd _kmod_build_$kvariant
#    make KERNELPATH="${ksrc}" KERNELRELEASE=%{kverrel}${kvariant}  all
	make  default_config
	make %{?_smp_mflags} \
         KSRC="${ksrc}" \
         KVERS=%{kverrel}${kvariant:+$kvariant} \
         TARGET_MODDIR=$RPM_BUILD_ROOT/lib/modules/%{kverrel}${kvariant}/extra/%{kmod_name}
    popd
done


%install
rm -rf $RPM_BUILD_ROOT
for kvariant in %{kvariants}
do
	pushd _kmod_build_$kvariant
	make install DESTDIR=$RPM_BUILD_ROOT TARGET_MODDIR=$RPM_BUILD_ROOT/lib/modules/%{kverrel}${kvariant}/extra/%{kmod_name}
	popd
done

# Temporarily executable for stripping, fixed later in %%files.
chmod u+x $RPM_BUILD_ROOT/lib/modules/*/extra/%{kmod_name}/*

# FIXME -- this stuff should not be build in a kmod package!
rm -rf $RPM_BUILD_ROOT/sbin/ $RPM_BUILD_ROOT/usr/ $RPM_BUILD_ROOT/etc/ $RPM_BUILD_ROOT/init.d/wlan


%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Wed Feb 14 2007 kwizart < kwizart at gmail .com > - 0.2.5-6
- disable pci/pcmcia/plx

* Wed Dec 27 2006 kwizart < kwizart at gmail .com > - 0.2.5-5.kwizart.fc6
- fix build on 2.6.19
- Enabled PCMCIA PLX PCI

* Sat Nov 24 2006 kwizart < kwizart at gmail .com > - 0.2.5-4.kwizart.fc6
- fix build on 2.6.18

* Sun Sep 24 2006 kwizart < kwizat at gmail.com > - 0.2.5-3.kwizart.FC5
- Update to 0.2.5

* Thu Sep 07 2006 kwizart < kwizart at gmail.com > - 0.2.3-2_FC5
- Patch10

* Sat Jul 24 2006 kwizart at < fedora-france.org >
- inital release ( based on madwifi from livna.org )
  with help W. Michael Petullo <mike[at]flyn.org>
  
